function [ intg, lk, Zs, Cs, Is, Ks, Ns, NNs, Ws, T ] = decide_cluster( row, col, R, Zs, Cs, Is, Ks, Ns, NNs, Ws, param, settings )

i=row;
m=col;
oZs_m=Zs(:,m);
oCs_m= Cs{m};
oIs_m=Is{m};
oWs_m=Ws{m};




Zs_m=Zs(:,m);
Cs_m= Cs{m};
Is_m=Is{m};
Ks_m=Ks(m);
Ns_m= Ns(m);
NNs_m= NNs{m};
Ws_m=Ws{m};



m_aux = settings.m_aux;
sigma_w = param.sigma_w;
mu_w = param.mu_w ;
% sigma_w1 = param.sigma_w1;
% mu_w1 = param.mu_w1 ;
% sigma_w2 = param.sigma_w2;
% mu_w2 = param.mu_w2 ;


ggamma = param.ggamma;
%

%        fprintf('check if singleton\n');

cluster = Cs_m(find(Is_m==i)); % cluster is current component that data item i belongs to
NNs_m(cluster) = NNs_m(cluster) - 1; % subtract from number of data items in cluster
% check if current cluster is singleton

if NNs_m(cluster) == 0
    
    Ks_m = Ks_m - 1;
    NNs_m(cluster)=[];
    idx = find(Cs_m>cluster);
    Cs_m(idx) = Cs_m(idx) - 1;
    W_aux = cell(1, m_aux);
    self = Ws_m(cluster,cluster);
    col = Ws_m(:,cluster);
    col(cluster) = [];
    row = Ws_m(cluster,:);
    row(cluster) = [];
    
    
    
    Ws_m(cluster,:)=[];
    Ws_m(:,cluster)=[];
    W_aux{1} = [Ws_m col ];
    row = [row self];
    W_aux{1} = [W_aux{1}; row];
    
    
    for r=2:m_aux
        
        col = (mu_w+sigma_w * randn(1, Ks_m))';
        row= mu_w+sigma_w * randn(1, Ks_m+1);
        W_aux{r} = [Ws_m col];
        W_aux{r} = [ W_aux{r}; row];
    end
    %     for r=2:m_aux
    %         ccol=zeros(1, Ks_m+1)';
    %         rrow=zeros(1, Ks_m+1);
    %         for cc=1:(Ks_m+1)
    %             if rand<0.5
    %                 tw =param.mu_w1+param.sigma_w1*randn(1,1);
    %                 ccol(cc)=tw;
    %                 rrow(cc)=tw;
    %             else
    %                 tw =param.mu_w2+param.sigma_w2*randn(1,1);
    %                 ccol(cc)=tw;
    %                 rrow(cc)=tw;
    %             end
    %         end
    %
    %         W_aux{r} = [Ws_m ccol(1:(end-1))];
    %         W_aux{r} = [ W_aux{r}; rrow];
    %     end
    %
    
else
    
    W_aux = cell(1, m_aux);
    for r=1:m_aux
        col=(mu_w+sigma_w * randn(1, Ks_m))';
        row=mu_w+sigma_w * randn(1, Ks_m+1);
        W_aux{r} = [Ws_m col];
        W_aux{r} = [W_aux{r};  row];
        
        
    end
    
    %     for r=1:m_aux
    %
    %         ccol=zeros(1, Ks_m+1)';
    %         rrow=zeros(1, Ks_m+1);
    %         for cc=1:(Ks_m+1)
    %             if rand<0.5
    %                 tw =param.mu_w1+param.sigma_w1*randn(1,1);
    %                 ccol(cc)=tw;
    %                 rrow(cc)=tw;
    %             else
    %                 tw =param.mu_w2+param.sigma_w2*randn(1,1);
    %                 ccol(cc)=tw;
    %                 rrow(cc)=tw;
    %             end
    %         end
    %
    %         W_aux{r} = [Ws_m ccol(1:(end-1))];
    %         W_aux{r} = [ W_aux{r}; rrow];
    %     end
    
end



W_temp =Ws_m;
C_temp = Cs_m;
p= log(NNs_m.*(1/(ggamma+Ns_m-1)));
p((end+1):(end+m_aux)) = log((ggamma/m_aux)) -log(ggamma+Ns_m-1);
lh=zeros(1,Ks_m+m_aux);
TT=cell(1,Ks_m+m_aux);


for k = 1:Ks_m+m_aux
    
    if k<Ks_m+1
        C_temp(find(Is_m==i))=k;
    else
        C_temp(find(Is_m==i))=Ks_m+1;
        r = k - Ks_m;
        W_temp = W_aux{r};
    end
    %
    %     Zs(:,m)=Zs_m;
    %     Cs{m}=C_temp;
    %     Is{m}=Is_m;
    %     Ks(m)=Ks_m;
    %     Ns(m)=Ns_m;
    %     NNs{m}=NNs_m;
    %     Ws{m}=W_temp;
    %     [lh(k) TT{k}] = compute_likelihood(R, Zs, Cs, Is, Ws, param, settings);
    
    [ lh(k) TT{k}] = compute_likelihood_new(i,oZs_m, {oCs_m}, {oIs_m}, {oWs_m}, R,  Zs_m, {C_temp}, {Is_m}, {W_temp}, param, settings);
    
    p(k) = p(k) +lh(k);
end

%compute the sum of logs (needed for integration for computing z=1)

intg=log_sum_exp(p);
p=exp(p-intg);


% sample from the conditional probabilities
uu = rand;
kk = 1+sum(uu>cumsum(p));

T=TT{kk};
lk=lh(kk);
if kk>Ks_m
    
    Ws_m = W_aux{kk-Ks_m};
    kk = Ks_m+1;
    Ks_m=Ks_m+1;
    NNs_m(kk)=0;
end

Cs_m(find(Is_m==i))=kk;
NNs_m(kk) = NNs_m(kk) + 1; % increment number of data items in component kk
assert(max(Cs_m) == size(Ws_m,2));


Zs(:,m)=Zs_m;
Cs{m}=Cs_m;
Is{m}=Is_m;
Ks(m)=Ks_m;
Ns(m)=Ns_m;
NNs{m}=NNs_m;
Ws{m}=Ws_m;


end

