function [ param ] = slice_sampler_hyper_CRP(param)

%p(ggama | z) prop_to p(z|ggama)*p(ggama)
%p(ggama)=exp(-gamma) --> log_prior=-gamma
 Zs=param.Zscur;
 Cs=param.Cscur;
 Is=param.Iscur;
 Ks=param.Kscur;
 Ns=param.Nscur;
 NNs=param.NNscur;
 Ws=param.Wscur;
 
 ggamma=param.ggamma;


M=size(Cs,2);


temp = 0;

for m=1:M
    for i=1:Ks(m)
        temp  = temp + gammaln(NNs{m}(i));
        
    end

end


f= @(g) M*gammaln(g)+sum(Ks)*log(g) +temp - sum(gammaln(g+Ns));

% grange=0.01:0.01:2;
% plot(grange,exp(arrayfun(f,grange)-grange)); 
% pause; 

h =@(x) f(exp(x))+x-exp(x);
N = 1;

t= slicesample(log(ggamma),N,'logpdf',h,'thin',1,'burnin',0);
param.ggamma=exp(t);

 param.Zscur=Zs;
 param.Cscur=Cs;
 param.Iscur=Is;
 param.Kscur=Ks;
 param.Nscur=Ns;
 param.NNscur=NNs;
 param.Wscur=Ws;
 
 
end

