% Konstantina Palla <kp376@cam.ac.uk>
% University of Cambridge
% Created: February 2012
% Modified: August 2012

function [Zs0, Cs0, Is0, Ks0, Ns0, NNs0, Ws0, logl0, T0]=turn_feature_off(R, row, col, Zs, Cs, Is, Ks, Ns, NNs, Ws, param, settings)

i=row;
m=col;

Zs0=Zs;
Cs0=Cs;
Is0=Is;
Ks0=Ks;
Ns0=Ns;
NNs0=NNs;
Ws0=Ws;


                
%if new value different from the old one,
%update the structures correspondingly

   if Zs0(i,m)==1
       
      
            
            % turn it off
            Zs0(i,m)=0;
            %check whether the z_im is singleton
            %if yes, remove the relevant cluster form the clustering
            
            current_cluster =Cs0{m}(find(Is0{m}==i)); % current component that data item
            % z_im belongs to
            
            
            
            Ns0(m) = Ns0(m) -1;
            % subtract from number of data items in component
            % current_cluster
            NNs0{m}(current_cluster) =NNs0{m}(current_cluster)- 1;
            
            % delete active component if it has become empty
            if NNs0{m}(current_cluster) == 0,
                Ks0(m) = Ks0(m) - 1;
                NNs0{m}(current_cluster)=[];
                
                idx = find(Cs0{m}>current_cluster);
                
                Cs0{m}(idx) = Cs0{m}(idx) - 1;
                
                %delete the weights of current_cluster in W
                Ws0{m}(current_cluster,:)=[];
                Ws0{m}(:,current_cluster)=[];
                
            end
            
            Cs0{m}(find(Is0{m}==i))=[];
            %update I
            Is0{m} = find(Zs0(:,m));
             
             [logl0 T0]=  compute_likelihood_new(i,Zs(:,m), Cs(m), Is(m), Ws(m), R, Zs0(:,m), Cs0(m), Is0(m), Ws0(m), param, settings); %check
   else
       [logl0 T0]=  compute_likelihood_new(i, Zs0(:,m), Cs0(m), Is0(m), Ws0(m), R, Zs0(:,m), Cs0(m), Is0(m), Ws0(m), param, settings); 
   end
   
                    
   
end




