function [cc Ns] = crpgen(D, alpha, K)

switch(nargin)
    case 2
        K = -1;
        
end


if K==-1
    K=0;
    Ns=zeros(1,K);
    cc=zeros(1,D);
    for d=1:D
        p= log(Ns.*(1/(alpha+D-1)));
        p(end+1) = log(alpha) -log(alpha+D-1);
        
        p = exp(p-max(p));
        p=p/(sum(p));
        
        uu = rand;
        kk = 1+sum(uu>cumsum(p));
        
        if kk>K
            
            kk = K+1;
            K=K+1;
            Ns(kk)=0;
            
        end
        
        cc(d)=kk;
        Ns(kk) = Ns(kk) + 1;
        
    end
    
    
    
    
else
    
    Q=0;
    Ns=zeros(1,Q);
    cc=zeros(1,D);
    
    for d=1:D
        if Q<K
            p= log(Ns.*(1/(alpha+D-1)));
            p(end+1) = log(alpha) -log(alpha+D-1);
            
            p = exp(p-max(p));
            p=p/(sum(p));
            
            uu = rand;
            kk = 1+sum(uu>cumsum(p));
            
            if kk>K
                
                kk = Q+1;
                Q=Q+1;
                Ns(kk)=0;
                
            end
            
            cc(d)=kk;
            Ns(kk) = Ns(kk) + 1;
        else
            p= log(Ns.*(1/(alpha+D-1)));
            
            p = exp(p-max(p));
            p=p/(sum(p));
            
            uu = rand;
            kk = 1+sum(uu>cumsum(p));
            cc(d)=kk;
            Ns(kk) = Ns(kk) + 1;
        end
        
    end
    
    
    
    
    
    
end


end