% Konstantina Palla <kp376@cam.ac.uk>
% University of Cambridge
% Created: February 2012


function [ lkl_trn  T lkl_tst ] = compute_likelihood(R, Z, C, I, W, param, settings)



N = size(R, 1);
%M = size(Z, 2);

T=s_input_(R,W, C, I, Z);

Tb=T+param.bias; 
% Tb=T;
% Tb(T==0)=Tb(T==0)+param.bias;

l=-log(1+exp(Tb)); 

ra_train= settings.train_mask.*(l+R.*Tb);
ra_test=( settings.test_mask).*(l+R.*Tb);
lkl_trn = sum(sum(ra_train));
lkl_tst = sum(sum(ra_test));




end
