function [Zs1, Cs1, Is1, Ks1, Ns1, NNs1, Ws1, lk1, logl1, T1 ] = turn_feature_on(R, row, col, Zs, Cs, Is, Ks, Ns, NNs, Ws, param, settings)

i=row;
m=col;

Zs1=Zs;
Cs1=Cs;
Is1=Is;
Ks1=Ks;
Ns1=Ns;
NNs1=NNs;
Ws1=Ws;


if Zs1(i,m)~=1
    %put it in a cluster -already present in the m_th clustering, new or
    %old - sample from prior
    Zs1(i, m)=1;
    Is1{m}=find(Zs1(:,m));
    Ns1(m) = Ns1(m)+1;
    
    
    pr= log(NNs1{m}) -log((param.ggamma+Ns1(m)-1));
    pr=[pr log(param.ggamma)-log(param.ggamma+Ns1(m)-1)];
    p=pr;
    p = exp(p-max(p));
    p=p/(sum(p));
    % sample from the conditional probabilities
    uu = rand;
    cl = 1+sum(uu>cumsum(p));
    
    Wtem=[];
    if cl>Ks1(m)
        Wtem = [Ws1{m} (param.mu_w+param.sigma_w*randn(1, Ks1(m)))'];        
        Wtem = [Wtem;  param.mu_w+param.sigma_w*randn(1, Ks1(m)+1)];
        Ks1(m)=Ks1(m)+1;
        NNs1{m}(cl)=0;
        Ws1(m)={Wtem};
    end
%     if cl>Ks1(m)
%         ccol=zeros(1, Ks1(m)+1)';
%         rrow=zeros(1, Ks1(m)+1);
%         for cc=1:Ks1(m)+1
%             if rand<0.5
%                 tw =param.mu_w1+param.sigma_w1*randn(1,1);
%             ccol(cc)=tw;
%             rrow(cc)=tw;
%             else
%                 tw =param.mu_w2+param.sigma_w2*randn(1,1);
%             ccol(cc)=tw;
%             rrow(cc)=tw;
%             end
%         end
%         
%         Wtem = [Ws1{m} ccol(1:(end-1))];        
%         Wtem = [Wtem;  rrow];
%         Ks1(m)=Ks1(m)+1;
%         NNs1{m}(cl)=0;
%         Ws1(m)={Wtem};
%     end
    
    NNs1{m}(cl) = NNs1{m}(cl)+1;
    if find(Is1{m}==i)==1
        Cs1{m} = [cl Cs1{m}];
    elseif find(Is1{m}==i)==Ns1(m)
        Cs1{m} = [Cs1{m} cl];
    else
        Cs1{m} = [Cs1{m}(1:(find(Is1{m}==i)-1)) cl Cs1{m}(find(Is1{m}==i):end)];
    end
    [ltemp  T_]=compute_likelihood_new(i,Zs(:,m),Cs(m), Is(m), Ws(m), R, Zs1(:,m), Cs1(m), Is1(m), Ws1(m), param, settings);
% [ltemp  T_]=compute_likelihood(R, Zs1, Cs1, Is1, Ws1, param, settings);
    param.T=T_;
%     param.lk=ltemp;
    
    
end

[logl1, lk1,  Zs1, Cs1, Is1, Ks1, Ns1, NNs1, Ws1, T1 ] = decide_cluster(i, m, R, Zs1, Cs1, Is1, Ks1, Ns1, NNs1, Ws1, param, settings );
end
